import java.io.*;
import java.util.*;
import java.net.*;
import java.text.DateFormat;
import java.text.ParseException;

/**
 * NNTPФ̿HTMLΥ֤롣
 * @author	Conflict
 * @version	0.30
 */

public class NewsArchiver {
	//	饹ѿ  ////////////////////////////////////////////
	/**
	 * С
	 */
	public static final String VERSION = "0.30";
	
	//	եեޥå
	private static DateFormat df = null;
	
	//	饹
	private static ArticleManager manager = null;
	
	//	᥽å  //////////////////////////////////////////////
	
	/**
	 * ᥤ롼
	 * @param	arg		1ϡ̾
	 *					2ϡ롼̾
	 *					3ϡǡեΥǥ쥯ȥ
	 *					'/'դʤˡ
	 *					4ϡHTMLΥǥ쥯ȥ
	 *					'/'դʤˡ
	 *					5ϡindex.htmlɽץ
	 *					URL
	 *					6ϡɬפʾΥ桼̾
	 *					7ϡɬפʾΥѥɡ
	 */
	public static void main(String[] arg) {
		//	ǥ쥯ȥ
		if(arg.length < 5) {
			System.out.println("usage:\n"
				+ "    java NewsArchiver <server> <group> "
				+ "<data dir.> <html dir.> <url> [<user> <pass>]\n"
				+ "server      ̾'@'³ʤ\n"
				+ "group       롼̾\n"
				+ "data dir.   ǡեϥǥ쥯ȥ\n"
				+ "html dir.   HTMLեϥǥ쥯ȥ\n"
				+ "url         index.htmlɽURL\n"
				+ "user        ɬפʥФΥ桼̾\n"
				+ "pass        ɬפʥФΥѥ\n"
				+ "ǥ쥯ȥ'/'դʤ");
			System.exit(1);
		}
		String server   = arg[0];
		String group    = arg[1];
		String dat_path = arg[2];
		String out_path = arg[3];
		String back_url = arg[4];
		String user     = null;
		String pass     = null;
		
		if(arg.length > 5) {
			user = arg[5];
			pass = arg[6];
		}
		
//		System.out.println(" : " + out_path);
//		System.out.println("ϸ : " + in_path);
//		System.out.println("   : " + back_url);
		
		NewsArchiver archiver = new NewsArchiver();
		manager = ArticleManager.getInstance();
		
		//	ǥ쥯ȥ
		File dir;
		dir = new File(dat_path);
		dir.mkdir();
		dir = new File(out_path);
		dir.mkdir();
		
		//	饹
		manager.setDatastorePath(dat_path);
		manager.load();									//	¸
		
		//	μʥե롢С
		if(!server.equals("@"))
			archiver.getFromServer(server, group, user, pass);
		
		//	htmlν񤭽Ф
		archiver.writeHtml(out_path, back_url);
	}
	
	/**
	 * ǡHTMLؽ񤭽Ф
	 * @param	out_path	񤭽Фǥ쥯ȥꡣ'/'դʤ
	 * @param	back_url	index.htmlɽפURL
	 */
	protected void writeHtml(String out_path, String back_url) {
		System.out.println("HTMLե档");
		
		//	news򥽡ѤTreemap
		TreeMap date_tree = new TreeMap();			//	tree
		Iterator itr = manager.getArticles().iterator();
		while(itr.hasNext()) {
			Article art = (Article)itr.next();
			
			date_tree.put(art.getJavaDate(), art.getMessageID());
		}
		
		//	ڹ¤
		List root_ids = new ArrayList();			//	롼ȵID
		itr = date_tree.values().iterator();
		while(itr.hasNext()) {
			boolean root = true;
			String id = (String)itr.next();
			Article art = manager.get(id);
			
			List ref = art.getReferences();			//	Ȥ뵭
			if(ref != null) {						//	ȤƤ?
				ListIterator litr = ref.listIterator(ref.size());
				while(litr.hasPrevious()) {
					String ref_id = (String)litr.previous();
					
					//	εΥեˡεɲ
					Article art_ref = manager.get(ref_id);
					if(art_ref != null) {
						List referer = art_ref.getReferer();
						if(referer == null) {
							referer = new ArrayList();
							art_ref.setReferer(referer);
						}
						referer.add(id);
						root = false;
						break;
					}
				}
			}
			if(root) {
				root_ids.add(id);
			}
		}
		
		//	HTMLǤФ
		//	index.html
		String date = (new Date()).toString();
		try {
			FileWriter fw = new FileWriter(out_path + "/index.html");
			
			//	إåʬ
			fw.write(
				"<HTML>\n" + 
				"<HEAD>\n" + 
				"<TITLE>news archive</TITLE>\n" + 
				"</HEAD>\n" + 
				"<BODY>\n" + 
				"<A href=\"" + back_url + "\"></A>\n" + 
				"<HR>\n" + 
				"<B>Index by thread</B> at " + date + "<BR>\n" +
			"");
			
			//	ʬ
			fw.write("<UL>\n");
			itr = root_ids.iterator();
			while(itr.hasNext()) {
				printTitle(fw, (String)itr.next());
			}
			fw.write("</UL>\n");
			
			//	եåʬ
			fw.write(
				"<HR>\n" + 
				"<A href=\"" + back_url + "\"></A><BR>\n" + 
				"<FONT size=1>Created by Java NewsArchiver Ver." + VERSION + 
				" Copyright(C) by Conflict 2000-2001. " + 
				"All rights reserved.</FONT>" + 
				"<BR>\n" + 
				"</BODY>\n" + 
				"</HTML>\n" + 
			"");
			fw.close();
			
			//	Ƶ
			itr = manager.getArticles().iterator();
			while(itr.hasNext()) {
				Article art = (Article)itr.next();
				manager.outToHtml(art, out_path);
			}
		}
		catch(IOException e) {
			System.out.println("HTMLե񤭽Ф˥顼");
			e.printStackTrace();
			System.exit(1);
		}
		
		System.out.println("λޤ");
	}
	
	/**
	 * ΥȥƵŪɽ롣
	 * @param	out		衣
	 * @param	id		Ϥ뵭id
	 */
	protected void printTitle(Writer out, String id) {
		Article art = manager.get(id);
		
		if(df == null) {
			df = DateFormat.getDateTimeInstance(
						DateFormat.MEDIUM, DateFormat.SHORT, Locale.US);
		}
		
		try {
			//	ε
			String date = df.format(art.getJavaDate());
			out.write("<LI>" + art.getHtmlAnchor() + " (" + date + ")\n");
			
			//	ȤƤ뵭ɽ
			List referer = art.getReferer();
			if(referer != null && referer.size() > 0) {
				out.write("<UL>\n");
				Iterator itr = referer.iterator();
				while(itr.hasNext()) {
					printTitle(out, (String)itr.next());
				}
				out.write("</UL>\n");
			}
			
			out.write("</LI>\n");
		}
		catch(IOException e) {
			System.out.println("HTMLȥɽ˥顼");
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	/**
	 * Ф鵭ƥեȤ
	 * @param	server	ФΥۥ̾
	 * @param	group	롼̾
	 * @param	user	ǧڻΥ桼̾ǧڤפξnullǲġ
	 * @param	pass	ǧڻΥѥɡǧڤפξnullǲġ
	 */
	protected void getFromServer(String server, String group
												, String user, String pass) {
		//	ФȤΥͥĥ
		Socket socket = null;
		PrintWriter out = null;
		BufferedReader in = null;
		
		System.out.println("Ф³档");
		
		try {
			socket = new Socket(server, 119);
			out = new PrintWriter(new OutputStreamWriter(
							socket.getOutputStream()), true);
			in  = new BufferedReader(new InputStreamReader(
							socket.getInputStream()));
//			out = new PrintWriter(new OutputStreamWriter(
//							socket.getOutputStream(), "ISO2022JP"), true);
//			in  = new BufferedReader(new InputStreamReader(
//							socket.getInputStream(), "ISO2022JP"));
		}
		catch(UnknownHostException e) {
			System.err.println(server + "³Ǥޤ");
			System.exit(1);
		}
		catch(IOException e) {
			System.err.println(server + "I/Oޤ");
			System.exit(1);
		}
		
		String stat;
		String line;
		Vector v_token;
		
		try {
			//	ǽιԤɽ
			line = in.readLine();
			System.out.println("" + server + "³ޤ");
			System.out.println(" : " + line);
			
			//	
			if(user != null && pass != null) {
				out.println("AUTHINFO USER " + user);
				
				v_token = parseResponse(in.readLine());
				stat = (String)v_token.elementAt(0);
				if(!stat.equals("381")) {
					System.out.println("桼̾ǧڤޤǤ");
					in.close();
					out.close();
					socket.close();
					System.exit(1);
				}
				
				out.println("AUTHINFO PASS " + pass);
				
				v_token = parseResponse(in.readLine());
				stat = (String)v_token.elementAt(0);
				if(!stat.equals("281")) {
					System.out.println("ѥɤǧڤޤǤ");
					in.close();
					out.close();
					socket.close();
					System.exit(1);
				}
				
				System.out.println("Ф˥󤷤ޤ");
			}
			
			//	롼׾
			out.println("GROUP " + group);
			
			v_token = parseResponse(in.readLine());
			stat = (String)v_token.elementAt(0);
			if(stat.startsWith("4")) {
				if(stat.equals("411")) {
					System.out.println("롼פĤޤ");
				}
				else {
					System.out.println("۾郎ȯޤ:" + stat);
				}
				in.close();
				out.close();
				socket.close();
				System.exit(1);
			}
			System.out.println("롼פ򤷤ޤ");
			
			int num_arts  = Integer.parseInt((String)v_token.elementAt(1));
			int num_start = Integer.parseInt((String)v_token.elementAt(2));
			int num_end   = Integer.parseInt((String)v_token.elementAt(3));
			
			//	¸
			if(num_arts <= 0 || num_start > num_end) {
				return;								//	ʤ
			}
			System.out.println("õƤޤ");
			out.println("STAT " + num_start);
			for(;;) {
				v_token = parseResponse(in.readLine());
				stat = (String)v_token.elementAt(0);
				if(stat.startsWith("4"))
					break;							//	ʤ
				
				int num = Integer.parseInt((String)v_token.elementAt(1));
				String id = (String)v_token.elementAt(2);
				
				Article art;
				if((art = manager.get(id)) == null) {
					//	̤ε
					art = new Article(id);
					out.println("ARTICLE");
					
					v_token = parseResponse(in.readLine());
					stat = (String)v_token.elementAt(0);
					if(stat.startsWith("4") || stat.equals("223"))
						break;							//	쥹ݥ󥹰۾
					
					art.receive(in, num);
					manager.store(art);
				}
				out.println("NEXT");
			}
			
			out.println("QUIT");
			v_token = parseResponse(in.readLine());
			
			in.close();
			out.close();
			socket.close();
		}
		catch(IOException e) {
			System.out.println("IO顼ȯޤ");
			e.printStackTrace();
			try { in.close(); } catch(IOException e2) {}
			out.close();
			try { socket.close(); } catch(IOException e2) {}
			System.exit(1);
		}
		System.out.println("ФȤ³Ǥޤ");
	}
	
	/**
	 * 쥹ݥ󥹹Ԥ򥹥ڡʤɤζʸǥȡʬ򤹤롣
	 * @param	line	ԡ
	 * @return	ȡStringˤ
	 */
	protected Vector parseResponse(String line) {
//		System.out.println(line);			//	for debug
		Vector v = new Vector();
		
		StringTokenizer st = new StringTokenizer(line);
		while(st.hasMoreTokens()) {
			v.add(st.nextToken());
		}
		return v;
	}
}
