import java.io.*;
import java.util.*;
import java.text.*;

/**
 * newsεɽ륯饹
 * @author	Conflict
 * @version	0.30
 */
public class Article {
	//	饹ѿ  ////////////////////////////////////////////////////
	
	//	ФǻѤĥإå
	private static final String XHEAD_NUMBER    = "X-NewsArchiver-Number: ";
	private static final String XHEAD_TIMESTAMP = "X-NewsArchiver-Millis: ";
	
	//	newsѴѤΥեޥå
	private static SimpleDateFormat df1 = null;
	private static SimpleDateFormat df2 = null;
	
	//	MIME󥳡ɤΥإå
	private static final String MIME_HEAD = "=?ISO-2022-JP?B?";
	
	//	MIMEǥѤ
	private static int[] reverse64;
	
	//	MIMEǥκǾǥå
	private static int min64Char;
	
	//	󥹥ѿ  /////////////////////////////////////////////
	
	//	إå
	private String head = null;
	//	ʸ
	private String body = null;
	
	//	إåγ°
	private String messageID = null;
	private String date = null;
	private Date javaDate = new Date(0);
	private String from = null;
	private String subject = null;
	private String charset = null;
	private List references = null;
	
	//	newsФ󼨤줿ֹ
	private int number = 0;
	//	archive
	private Date archiveDate = new Date(0);
	
	//	refererΥåID
	private List referer = null;
	
	//	᥽å  ///////////////////////////////////////////////////
	
	/**
	 * ƥå˥饤
	 */
	static {
		String base64 = 
			"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
		
		min64Char = (int)'A';
		int max_64_char = 0;
		int len = base64.length();
		int i;
		
		for(i = 0; i < len; i++) {
			int c = (int)base64.charAt(i);
			if(max_64_char < c)
				max_64_char = c;
			if(min64Char > c)
				min64Char = c;
		}
		
		reverse64 = new int[max_64_char - min64Char + 1];
		
		for(i = 0; i < len; i++) {
			reverse64[(int)base64.charAt(i) - min64Char] = i;
		}
//		System.out.println("min " + min64Char + ",max " + max_64_char);
	}
	
	/**
	 * 󥹥ȥ饯
	 */
	public Article() {
		//	nop
	}
	
	/**
	 * åIDꤷ󥹥ȥ饯
	 * @param	id		åID
	 */
	public Article(String id) {
		messageID = id;
	}
	
	//	setter/getter  //////////////////////////////////////////////////
	
	/**
	 * head setter
	 */
	public void setHead(String head) {
		this.head = head;
	}

	/**
	 * head getter
	 */
	public String getHead() {
		return head;
	}

	/**
	 * body setter
	 */
	public void setBody(String body) {
		this.body = body;
	}

	/**
	 * body getter
	 */
	public String getBody() {
		return body;
	}

	/**
	 * messageID setter
	 */
	public void setMessageID(String messageID) {
		this.messageID = messageID;
	}

	/**
	 * messageID getter
	 */
	public String getMessageID() {
		return messageID;
	}

	/**
	 * date setter
	 */
	public void setDate(String date) {
		this.date = date;
	}

	/**
	 * date getter
	 */
	public String getDate() {
		return date;
	}

	/**
	 * javaDate setter
	 */
	public void setJavaDate(Date javaDate) {
		this.javaDate = javaDate;
	}

	/**
	 * javaDate getter
	 */
	public Date getJavaDate() {
		return javaDate;
	}

	/**
	 * from setter
	 */
	public void setFrom(String from) {
		this.from = from;
	}

	/**
	 * from getter
	 */
	public String getFrom() {
		return from;
	}

	/**
	 * subject setter
	 */
	public void setSubject(String subject) {
		this.subject = subject;
	}

	/**
	 * subject getter
	 */
	public String getSubject() {
		return subject;
	}

	/**
	 * charset setter
	 */
	public void setCharset(String charset) {
		this.charset = charset;
	}

	/**
	 * charset getter
	 */
	public String getCharset() {
		return charset;
	}

	/**
	 * references setter
	 */
	public void setReferences(List references) {
		this.references = references;
	}

	/**
	 * references getter
	 */
	public List getReferences() {
		return references;
	}

	/**
	 * number setter
	 */
	public void setNumber(int number) {
		this.number = number;
	}

	/**
	 * number getter
	 */
	public int getNumber() {
		return number;
	}

	/**
	 * archiveDate setter
	 */
	public void setArchiveDate(Date archiveDate) {
		this.archiveDate = archiveDate;
	}

	/**
	 * archiveDate getter
	 */
	public Date getArchiveDate() {
		return archiveDate;
	}

	/**
	 * referer setter
	 */
	public void setReferer(List referer) {
		this.referer = referer;
	}

	/**
	 * referer getter
	 */
	public List getReferer() {
		return referer;
	}

	//	ӥͥ᥽å  ///////////////////////////////////////////////
	
	/**
	 * Ф鵭롣inˤϡARTICLEޥɤФ쥹ݥ󥹤
	 * ֤뤳ȡåIDϼѤߤȤ롣
	 * @param	in		ФȤSocketBufferedReader
	 * @param	num		εεֹ档֤εɽ롣
	 * @throws	IOException
	 */
	public void receive(BufferedReader in, int num) throws IOException {
		String s;
		String newline = "\n";
		
		//	إåɤ߹
		StringBuffer sb = new StringBuffer();
		while((s = in.readLine()) != null) {
			if(s.length() == 0)
				break;
			
			sb.append(s);
			sb.append(newline);
		}
		
		//	Ѿɲ
		sb.append(XHEAD_NUMBER + num + "\n");
		sb.append(XHEAD_TIMESTAMP + System.currentTimeMillis() + "\n");
		head = sb.toString();
		
		//	ʸɤ߹
		sb = new StringBuffer();
		while((s = in.readLine()) != null) {
			if(s.equals("."))
				break;
			if(s.startsWith(".."))
				s = s.substring(1);
			
			sb.append(s);
			sb.append(newline);
		}
		body = sb.toString();
		
		//	إå
		parseHeader();
		
		//	ǡȥ˽񤭽Ф
//		writeToFile();
		
		System.out.println(" : " + subject + "(" + from + ")");
	}
	
	/**
	 * إåʸ󤫤Ƽ°˳Ǽ롣
	 */
	public void parseHeader() {
		//	إå
		StringTokenizer tokens = new StringTokenizer(head, "\n");
		
		if(!tokens.hasMoreTokens())					//	ԤҤȤĤʤ
			return;
		String s = null;
		String s_next = tokens.nextToken();
		
		while(s_next != null) {
			s = s_next;
			
			//	ʣԤΥإå1ԤˤޤȤ
			for(;;) {
				if(!tokens.hasMoreTokens()) {
					s_next = null;
					break;
				}
				s_next = tokens.nextToken();		//	ι
				
				char c = s_next.charAt(0);
				if(c != '\t' && c != ' ')
					break;
				
				s += s_next.substring(1);
			}
			int space = s.indexOf(' ');
			
			//	إåβ
			if(s.startsWith("Date: ")) {
				date = s.substring(space + 1);
				javaDate = parseHeadDate(date);
			}
			else if(s.startsWith("Content-Type: ")) {
				int start = s.indexOf("charset=");
				int end;
				int delimiter;
				if(start >= 0) {
					start += 8;							//	ϰ
					delimiter = ';';					//	ڤʸ
					
					if(s.charAt(start) == '\"') {
						start++;
						delimiter = '\"';
					}
					
					end = s.indexOf(delimiter, start);
					if(end > start) {					//	ڤʸ
						charset = s.substring(start, end);
					}
					else {								//	ڤʸʤ
						charset = s.substring(start).trim();
					}
				}
			}
			else if(s.startsWith("From: ") || s.startsWith("Subject: ")) {
				//	MIME󥳡ɤƤǽΤ
				boolean is_from = s.startsWith("From: ");
				
				String src = s.substring(space + 1);
				String dst = null;
				
				if(src.indexOf("\033$B") != -1) {					//	JIS?
					try {
						dst = new String(src.getBytes(), "ISO2022JP");
					}
					catch(UnsupportedEncodingException e) {
						dst = src;
					}
				}
				else if(src.toUpperCase().indexOf(MIME_HEAD) != -1) {
					//	MIME
					dst = mimeDecode(src);
				}
				else {
					dst = src;
				}
				
				if(is_from)
					from = dst;
				else
					subject = dst;
			}
			else if(s.startsWith("References: ")) {
				String ref_ids = s.substring(space + 1);
				references = splitReferences(ref_ids);
			}
			else if(s.startsWith(XHEAD_NUMBER)) {
				number = Integer.parseInt(s.substring(space + 1));
			}
			else if(s.startsWith(XHEAD_TIMESTAMP)) {
				archiveDate = new Date(Long.parseLong(s.substring(space + 1)));
			}
		}
		
		//	Сб
		if(archiveDate == null) {
			archiveDate = new Date(0);
		}
	}
	
	/**
	 * Υإåϡ
	 * @param	str		Ϥʸ
	 * @return	Ϥ
	 */
	protected static Date parseHeadDate(String str) {
		//	եեޥå
		if(df1 == null) {
			//	Wed, 27 Sep 2000 09:01:11 +0900
			df1 = new SimpleDateFormat(
						"EEE, d MMM yyyy HH:mm:ss z", Locale.US);
			df2 = new SimpleDateFormat(
						"d MMM yyyy HH:mm:ss z", Locale.US);
		}
		
		ParsePosition ppos = new ParsePosition(0);
		Date d = df1.parse(str, ppos);
		
		if(d == null) {
			ppos = new ParsePosition(0);
			d = df2.parse(str, ppos);
		}
		if(d == null) {
			System.out.println("եեޥåȰ۾ : " + str);
			d = new Date(System.currentTimeMillis());
		}
		return d;
	}
	
	/**
	 * ReferencesMessageIDʬ䤹롣
	 * @param	str		Referencesʸ
	 * @return	ʬ䤷StringΥꥹȡ
	 */
	protected List splitReferences(String str) {
		for(;;) {
			int pos = str.indexOf("><");
			if(pos == -1)
				break;
			str = str.substring(0, pos) + "> <" + str.substring(pos + 2);
		}
		
		List ids = new ArrayList();
		StringTokenizer st = new StringTokenizer(str);
		while(st.hasMoreTokens()) {
			String id = st.nextToken().trim();
			if(id.length() > 0) {
				ids.add(id);
			}
		}
		return ids;
	}
	
	/**
	 * BODYʸɥǥɤԤʤ
	 * @return	ǥɤBODY
	 */
	public String getDecodedBody() {
		//	ʸʸѴ
		String body_dec = null;
		
		try {
			if(charset != null) {
				//	charsetꤢ
				String cset = charset.toLowerCase();
				String enc = null;
				if(cset.equals("iso-2022-jp"))
					enc = "ISO2022JP";
				else if(cset.equals("utf-8"))
					enc = "UTF8";
				
				if(enc != null)
					body_dec = new String(body.getBytes(), enc);
			}
			else if(body.indexOf("\033$B") != -1) {			//	JIS?
				body_dec = new String(body.getBytes(), "ISO2022JP");
			}
		}
		catch(UnsupportedEncodingException e) {
			//	nop
		}
		
		if(body_dec == null)
			body_dec = body;
		
		return body_dec;
	}
	
	/**
	 * εؤΥ󥯤򼨤HTMLʸ"&lt;A href=  &lt/A&gt;"ˤ֤
	 * @return	HTMLʸ
	 */
	public String getHtmlAnchor() {
		return "<A href=\"" + ArticleManager.idToFileName(messageID) 
			+ ".html\"> [" + number + "] " 
			+ escape(subject) + "</A> " + escape(from);
	}
	
	/**
	 * ɽHTML롣
	 * @return	HTMLʸ
	 */
	public String toHtml() {
		ArticleManager manager = ArticleManager.getInstance();
		
		StringBuffer sb = new StringBuffer();
		
		//	إåʬ
		sb.append(
			"<HTML>\n" + 
			"<HEAD>\n" + 
			"<TITLE>article " + number + "</TITLE>\n" + 
			"</HEAD>\n" + 
			"<BODY>\n" + 
			"<A href=\"index.html\"></A>\n" + 
			"<HR>\n" + 
			"<FONT size=+2>[" + number + "] " + 
			escape(subject) + "</FONT><BR>\n" + 
			"From: <B>" + escape(from) + "</B><BR>\n" + 
			"Date: <B>" + escape(date) + "</B><BR>\n" + 
			"<HR>\n" + 
		"");
		
		//	ʸ
		sb.append("<PRE>" + escape_body(manager.getBody(this)) + "</PRE>");
		
		//	եåʬ
		sb.append("<HR>\n");
		
		//	ελȤ뵭
		if(references != null && references.size() > 0) {
			sb.append(
				"<B>References:</B><BR>\n" + 
				"<UL>\n" + 
			"");
			
			Iterator itr = references.iterator();
			while(itr.hasNext()) {
				String id = (String)itr.next();
				Article refer = manager.get(id);
				if(refer != null) {
					sb.append("<LI>" + refer.getHtmlAnchor() + "</LI>\n");
				}
				else {
					sb.append("<LI>" + escape(id) + "</LI>\n");
				}
			}
			sb.append("</UL>\n");
		}
		
		//	εؤΥե
		if(referer != null && referer.size() > 0) {
			sb.append(
				"<B>Follow-Ups:</B><BR>\n" + 
				"<UL>\n" + 
			"");
			
			Iterator itr = referer.iterator();
			while(itr.hasNext()) {
				String id = (String)itr.next();
				Article follow = manager.get(id);
				if(follow != null) {
					sb.append("<LI>" + follow.getHtmlAnchor() + "</LI>\n");
				}
				else {
					sb.append("<LI>" + escape(id) + "</LI>\n");
				}
			}
			sb.append("</UL>\n");
		}
		
		//	HTMLĤΥإåǡ򻲹ͤɽ
		sb.append(
			"<HR>\n" 
			+ "<FONT size=-1>" + escape(head) + "</FONT>\n"
			+ "<HR>\n" 
			+ "<A href=\"index.html\"></A>\n" 
			+ "</BODY>\n" 
			+ "</HTML>\n");
		
		return sb.toString();
	}
	
	/**
	 * ʸ'&lt;''&gt;''\n''&amp;lt;''&amp;gt;'
	 * '&lt;BR&gt;'֤롣
	 * @param	str		֤ʸ
	 * @return	֤ʸ
	 */
	protected static String escape(String str) {
		int[]    from_chr_array = {'<', '>', '\n'};
		String[] to_str_array   = {"&lt;", "&gt;", "<BR>"};
		
		return escape_common(str, from_chr_array, to_str_array);
	}
	
	/**
	 * ʸ'&lt;''&gt;'' ''&amp;lt;''&amp;gt;'
	 * '&amp;nbsp;'֤롣
	 * @param	str		֤ʸ
	 * @return	֤ʸ
	 */
	protected static String escape_body(String str) {
		int[]    from_chr_array = {'<', '>', ' '};
		String[] to_str_array   = {"&lt;", "&gt;", "&nbsp;"};
		
		return escape_common(str, from_chr_array, to_str_array);
	}
	
	/**
	 * ʸ¸ߤ롢Ϳ줿ʸ򡢻ʸ֤롣
	 * @param	str				֤»ܤʸ
	 * @param	from_chr_array	֤ʸ
	 * @param	to_str_array	֤ʸ
	 * @return	֤ʸ
	 */
	private static String escape_common(String str, 
							int[] from_chr_array, String[] to_str_array) {
		if(str == null)
			return null;
		
		for(int i = 0; i < from_chr_array.length; i++) {
			int    from_chr = from_chr_array[i];
			String to_str   = to_str_array[i];
			
			for(;;) {
				int pos = str.indexOf(from_chr);
				if(pos == -1)
					break;
				str = str.substring(0, pos) + to_str + str.substring(pos + 1);
			}
		}
		return str;
	}
	
	/**
	 * MIMEǥɤԤʤ
	 * @param	src		ǥоݤʸ
	 * @return	ǥɤʸ
	 */
	protected String mimeDecode(String src) {
		for(;;) {
			String upper = src.toUpperCase();
			int start = upper.indexOf(MIME_HEAD);
			int end   = upper.indexOf("?=", start);
			
			if(start < 0 || start >= end)			//	MIMEΥ֥åʤ?
				break;
			
			String pre  = src.substring(0, start);
			String b64  = src.substring(start + MIME_HEAD.length(), end);
			String post = src.substring(end + 2);
			
			src = pre + base64Decode(b64) + post;
		}
		return src;
	}
	
	/**
	 * BASE64ΥǥɤԤʤ
	 * @param	src		ǥоݤʸ
	 * @return	ǥɤʸ
	 */
	private String base64Decode(String src) {
		int srclen = src.length();
		
		//	åڤ
		int tail = src.indexOf('=');
		if(tail >= 0)
			srclen = tail;
		
		//	ǥɥХåեسǼ
		int srclen4 = (srclen + 3) & ~3;		//	4ܿڤ夲
		int[] dec = new int[srclen4];
		int i;
		for(i = 0; i < srclen; i++) {
			try {
				dec[i] = reverse64[(int)src.charAt(i) - min64Char];
			}
			catch(IndexOutOfBoundsException e) {
				//	ʸ¸ߤ
				System.out.println("ERROR:" + (int)src.charAt(i));
			}
		}
		
		//	ǥ
		int dstlen = srclen * 3 / 4;
		byte[] dst = new byte[dstlen];
		int j = 0;
		for(i = 0; i < srclen4; i += 4) {
			try {
				dst[j++] = (byte)((dec[i  ] << 2) | (dec[i+1] >> 4));
				dst[j++] = (byte)((dec[i+1] << 4) | (dec[i+2] >> 2));
				dst[j++] = (byte)((dec[i+2] << 6) | (dec[i+3]     ));
			}
			catch(IndexOutOfBoundsException e) {
				break;
			}
		}
		
		//	JISǥեȥ󥳡ǥ󥰤Ѵ֤
		try {
			return new String(dst, "JIS");
		}
		catch(UnsupportedEncodingException e) {
			return null;
		}
	}
}
